-- j = Save Index
_CONFLICTING_QUESTS = {
    -- Skirmish
    [1] = {
        -- Skirmish Instances
        [1] = {
            -- Siege of Gondamon
            -- [4]: Quest name is The Siege of Gondamon, no issue in English

            -- Trouble in Tuckborough
            [5] = {
                ["ISREPEATABLE"] = true; 
                ["QUESTNAME"] = { ["EN"] = "Skirmish / Skirmish Instances / Trouble in Tuckborough"; }; 
                ["ANNOUNCE"] = { 
                    ["EN"] = "The half-orc leading the assault has fallen. The remaining brigands and goblins are scattering. The Great Smials are safe"; 
                    ["DE"] = "Der Halbork, der den Angriff anführte, ist gefallen. Die verbleibenden Räuber und Bilwisse zerstreuen sich. Die Groß-Smials sind sicher.";
                    ["FR"] = "Le semi-Orque menant l'assaut est mort. Les brigands et les gobelins encore en vie se dispersent. Les Grands Smials sont sauvés.";
                };
            };
            -- Storm on Methedras
            [6] = {
                ["ISREPEATABLE"] = true; 
                ["QUESTNAME"] = { ["EN"] = "Skirmish / Skirmish Instances / Storm on Methedras"; }; 
                ["ANNOUNCE"] = { 
                    ["EN"] = "Gwyllion and Echrud have been defeated, leaving the Old Woman's threat to Rohan empty";
                    ["DE"] = "Ihr habt Gwyllion, die alte Frau des Berges, besiegt.";
                    ["FR"] = "Vous avez vaincu Gwyllion, la Vieille femme de la montagne";
                };
                ["ISDELAYED"] = true; -- Quest finishes after talking with Saeradan and receiving reward.
            };
            -- Stand at Amon Sûl
            [7] = {
                ["ISREPEATABLE"] = true; 
                ["QUESTNAME"] = { ["EN"] = "Skirmish / Skirmish Instances / Stand at Amon Sûl"; }; 
                ["ANNOUNCE"] = {
                    ["EN"] = "The Cargûl has been vanquished, and Candaith has survived to carry word to Rivendell";
                    ["DE"] = "Der Cargûl wurde besiegt und Candaith hat überlebt, um in Bruchtal Bericht zu erstatten.";
                    ["FR"] = "Le Cargûl a été vaincu et Candaith a survécu. C'est lui qui ira annoncer la nouvelle à Fondcombe.";
                };
            };
            -- Thievery and Mischief
            [8] = {
                ["ISREPEATABLE"] = true; 
                ["QUESTNAME"] = { ["EN"] = "Skirmish / Skirmish Instances / Thievery and Mischief"; }; 
                ["ANNOUNCE"] = {
                    ["EN"] = "You have reclaimed Town Hall and freed the south of Bree.";
                    ["DE"] = "Ihr habt das Rathaus zurückerobert und den Süden von Bree befreit.";
                    ["FR"] = "Vous avez repris l'Hôtel de ville et libéré le sud de Bree.";
                };
            };
            -- Attack at Dawn
            [9] = {
                ["ISREPEATABLE"] = true; 
                ["QUESTNAME"] = { ["EN"] = "Skirmish / Skirmish Instances / Attack at Dawn"; }; 
                ["ANNOUNCE"] = {
                    ["EN"] = "Defeated Graug and secured the knowledge of Esteldín's location";
                    ["DE"] = "Besiegt Graug und sichert die Informationen über Esteldíns Lage.";
                    ["FR"] = "Graug éliminé et emplacement d'Esteldin obtenu";
                };
            };
            -- Defence of the Prancing Pony
            [10] = {
                ["ISREPEATABLE"] = true; 
                ["QUESTNAME"] = { ["EN"] = "Skirmish / Skirmish Instances / Defence of the Prancing Pony"; }; 
                ["ANNOUNCE"] = {
                    ["EN"] = "Goilag has been defeated. Bree is safe";
                    ["DE"] = "Goilag wurde besiegt. Bree ist wieder in Sicherheit.";
                    ["FR"] = "Goilag a été vaincu. Bree est sauvée";
                };
            };

            -- Ford of Bruinen
            -- [11]: Quest name is The Ford of Bruinen, no issue in English

            -- The Icy Crevasse
            [12] = {
                ["ISREPEATABLE"] = true; 
                ["QUESTNAME"] = { ["EN"] = "Skirmish / Skirmish Instances / The Icy Crevasse"; }; 
                ["ANNOUNCE"] = {
                    ["EN"] = "Angmar's plan has been foiled. Evendim is safe, for now.";
                    ["DE"] = "Angmars Plan wurde durchkreuzt. Evendim ist erst einmal in Sicherheit.";
                    ["FR"] = "Les plans de l'Angmar ont été contrecarrés. Evendim est en sécurité, pour le moment du moins.";
                };
            };

            -- The Battle of the Deep-way
            -- [13]: Quest name is Battle of the Deep-way, no issue in English

            -- The Battle of the Way of Smiths
            -- [14]: Quest name is Battle of the Way of Smiths, no issue in English

            -- The Battle of the Twenty-first Hall
            -- [15]: Quest name is Battle of the Twenty-first Hall, no issue in English

            -- Strike Against Dannenglor
            [16] = {
                ["ISREPEATABLE"] = true; 
                ["QUESTNAME"] = { ["EN"] = "Skirmish / Skirmish Instances / Strike Against Dannenglor"; }; 
                ["ANNOUNCE"] = {
                    ["EN"] = "The sorcerer and the threat from Dannenglor have been defeated. Audaghaim and the Golden Host are safe";
                    ["DE"] = "Der Zauberer und die Bedrohung von Dannenglor wurden besiegt. Audaghaim und das Goldene Heer sind sicher.";
                    ["FR"] = "Le sorcier et la menace de Dannenglor ont été vaincus. Audaghaim et l'Armée d'Or sont sains et saufs.";
                };
            };
            -- Protectors of Thangúlhad
            [17] = {
                ["ISREPEATABLE"] = true; 
                ["QUESTNAME"] = { ["EN"] = "Skirmish / Skirmish Instances / Protectors of Thangúlhad"; }; 
                ["ANNOUNCE"] = {
                    ["EN"] = "Mazaukal has been defeated. Thangúlhad is safe";
                    ["DE"] = "Mazaukal wurde besiegt. Thangúlhad ist sicher.";
                    ["FR"] = "Vous avez vaincu Mazaukal. Thangulhad est sécurisé.";
                };
            };
            -- Breaching the Necromancer's Gate
            [18] = {
                ["ISREPEATABLE"] = true; 
                ["QUESTNAME"] = { ["EN"] = "Skirmish / Skirmish Instances / Breaching the Necromancer's Gate"; }; 
                ["ANNOUNCE"] = {
                    ["EN"] = "The Necromancer's Gate has fallen. The heart of Dol Guldur is open for assault";
                    ["DE"] = "Das Tor des Geisterbeschwörers ist gefallen. Nun kann das Herz Dol Guldurs angegriffen werden.";
                    ["FR"] = "La Porte du Nécromancien est tombée. Il est désormais possible d'attaquer le cœur de Dol Guldur";
                };
            };
            -- Assault on the Ringwraiths' Lair
            [19] = {
                ["ISREPEATABLE"] = true; 
                ["QUESTNAME"] = { ["EN"] = "Skirmish / Skirmish Instances / Assault on the Ringwraiths' Lair"; }; 
                ["ANNOUNCE"] = {
                    ["EN"] = "You have claimed the Ringwraiths' Lair. The heart of Dol Guldur is now exposed";
                    ["DE"] = "Ihr habt das Versteck der Ringgeister erobert. Das Herz von Dol Guldur liegt nun offen.";
                    ["FR"] = "Vous avez conquis l'antre des Spectres de l'Anneau. Le cœur de Dol Guldur est désormais accessible.";
                };
            };
            -- The Battle in the Tower
            [20] = {
                ["ISREPEATABLE"] = true; 
                ["QUESTNAME"] = { ["EN"] = "Skirmish / Skirmish Instances / The Battle in the Tower"; }; 
                ["ANNOUNCE"] = {
                    ["EN"] = "You have claimed the Armoury and recovered Zigilburk";
                    ["DE"] = "Ihr habt die Waffenkammer erobert und Zigilburk zurückgeholt.";
                    ["FR"] = "Vous avez pris l'armurerie et récupéré Zigilburk";
                };
            };
            -- Rescue in Nûrz Ghâshu
            [21] = {
                ["ISREPEATABLE"] = true; 
                ["QUESTNAME"] = { ["EN"] = "Skirmish / Skirmish Instances / Rescue in Nûrz Ghâshu"; }; 
                ["ANNOUNCE"] = {
                    ["EN"] = "Erebún has been defeated and Golodir has been freed";
                    ["DE"] = "Erebún wurde besiegt und Golodir wurde befreit";
                    ["FR"] = "Erebun a été vaincu et Golodir a été libéré";
                };
                ["ISDELAYED"] = true; -- Quest finishes after talking with Corunir / Golodir
            };
            -- The Perfect Picnic
            -- TBD: Check quest announcement text
            -- TBD: Check if quest is delayed
            [22] = {
                ["ISREPEATABLE"] = true;
                ["QUESTNAME"] = { ["EN"] = "Skirmish / Skirmish Instances / The Perfect Picnic"; }; 
                ["ANNOUNCE"] = { 
                    ["EN"] = "The picnic has been saved. The rain even cooled things down!";
                };
                ["ISDELAYED"] = true; -- Quest finishes after eating food
            };
        };
    };
    -- Instances
    [2] = {
        -- Shadows of Angmar
        [1] = {
            -- Facing Your Fears
            --[24] = {
                -- Same objectives, so no entry needed.                
            --};
        };
        -- Mines of Moria
        [2] = {
            -- Eyes of the Enemy (Save Index)
            [62] = {
                ["ISREPEATABLE"] = true;
                ["QUESTNAME"] = { ["EN"] = "Eriador / The Trollshaws / Quest:Eyes of the Enemy (Repeatable)\n    (Defeat 6 hendrevail in the Bruinen Gorges)"; };
            };
        };
        -- Tower of Dol Guldur
        [4] = {
            -- Leave No One Behind
            [5] = {
                ["ISREPEATABLE"] = false;
                ["QUESTNAME"] = { ["EN"] = "Mordor / Minas Morgul / Quest:Leave No One Behind\n    (You have escaped from the Halls of Black Lore, but without Faeron. You must find him and discover if it was indeed Viznak you heard inside.)"; };
            };
        };
        -- Ashes of Osgiliath
        [8] = {
            -- The Lord of Pinions
            --[5] = {
                -- Same objectives, so no entry needed.
            --};
        };
        -- The Grey Mountains
        [11] = {
            -- Lost Lore of the Dwarf-holds: Thikil-gundu
            --[43] = {
                -- Same objectives, so no entry needed.
            --};
        };
    };
    -- The War
    [4] = {
        -- Osgiliath
        [3] = {
            -- The Battle for Osgiliath
            [1] = {
                ["ISREPEATABLE"] = false;
                ["QUESTNAME"] = { ["EN"] = "The War / The Sundering of Osgiliath / Quest:The Battle for Osgiliath\n    (Speak with Cangoras, Edenos, and Arthon)"; };
            };
        };
    };
    -- Class/Race/Epic
    [5] = {
        -- Class
        [1] = {
            -- Time of Need
            [146] = {
                ["ISREPEATABLE"] = false;
                ["QUESTNAME"] = { ["EN"] = "Eriador / Evendim / Quest:Time of Need\n    (Collect 6 supplies from hidden stores and brind them to Dannasssel)"; };
            };
            -- Tools of the Trade
            [183] = {
                ["ISREPEATABLE"] = true;
                ["QUESTNAME"] = { ["EN"] = "Gondor / Western Gondor: Belfalas / Quest:Tools of the Trade (Repeatable)\n    (Recover 8 tools)"; };
            };
            -- The Best Defence
            [251] = {
                ["ISREPEATABLE"] = false;
                ["QUESTNAME"] = { ["EN"] = "Rohan / Entwash Vale / Quest:The Best Defence\n    (Assist Lord Ingmar or Lady Góda)"; };
            };
            -- A Shot in the Dark
            [255] = {
                ["ISREPEATABLE"] = false;
                ["QUESTNAME"] = { ["EN"] = "Eridor / Gap of Rohan / Quest:A Shot in the Dark\n    (Complete Instance: Shot in the Dark, and Talk to Ardwyn at Forthbrond)"; };
            };
        };
        -- Race & Social
        [2] = {
            -- Baggins' Birthday
            [123] = {
                ["ISREPEATABLE"] = true;
                ["QUESTNAME"] = { ["EN"] = "Festival / Quest:Baggins' Birthday (Repeatable)\n    (Speak to Frodo Baggins in the Last Homely House in Rivendell)"; };
            };
            -- The Haunted Burrow
            [131] = {
                ["ISREPEATABLE"] = true;
                ["QUESTNAME"] = { ["EN"] = "Festival / Quest:The Haunted Burrow (Repeatable)\n    (Talk to Lobelia inside the Haunted Burrow, Talk to Opal Goodbody to discuss the fate of the Haunted Burrow)"; };
            };
        };
        -- Epic
        [3] = {
            -- Discovering the Descendant
            [26] = {
                ["ISREPEATABLE"] = false;
                ["QUESTNAME"] = { ["EN"] = "Eriador / Bree-land / Quest:Discovering the Descendant\n    (Complete the Instance: Discovering the Descendant, Talk to Éogar in the Horsefields)"; };
            };
        };
    };
    -- Eridaor
    [6] = {
        -- Lone-lands
        [4] = {
            -- Warg-slayer
            [24] = {
                ["ISREPEATABLE"] = false;
                ["QUESTNAME"] = { ["EN"] = "Eriador / The North Downs / Quest:Warg-slayer\n    (Defeat 8 wargs for Dagoras)"; };
            };
        };
        -- North Downs
        [5] = {
            -- Warg-slayer
            [20] = {
                ["ISREPEATABLE"] = false;
                ["QUESTNAME"] = { ["EN"] = "Eriador / The North Downs / Quest:Warg-slayer\n    (Defeat 8 wargs for Dagoras)"; };
            };
        };
        -- Misty Mountains
        [7] = {
            -- Warg-slayer
            [22] = {
                ["ISREPEATABLE"] = false;
                ["QUESTNAME"] = { ["EN"] = "Eriador / The North Downs / Quest:Warg-slayer\n    (Defeat 8 wargs for Dagoras)"; };
            };
        };
        -- Angmar
        [9] = {
            -- The Circle of Despair
            [4] = {
                ["ISREPEATABLE"] = false;
                ["QUESTNAME"] = { ["EN"] = "Mordor / Minas Morgul / Quest:The Circle of Dispair\n    (Aid Dornach in securing the Circle of Despair, and Talk to Candúr in Barad Arthir)"; };
            };
            -- The Seven Swords
            --[6] = {
                -- Deed completes before quest can be taken. No entry needed.
            --};
            -- Warg-slayer
            [20] = {
                ["ISREPEATABLE"] = false;
                ["QUESTNAME"] = { ["EN"] = "Eriador / The North Downs / Quest:Warg-slayer\n    (Defeat 8 wargs for Dagoras)"; };
            }
        };
        -- Forochel
        [10] = {
            -- The Lost Fellowship
            [8] = {
                ["ISREPEATABLE"] = false;
                ["QUESTNAME"] = { ["EN"] = "Eriador / Angmar / Quest:The Lost Fellowship\n    (Helegdir has asked for your help in ensuring the safety of a group of individuals known as the Lost Fellowship.)"; };
            };
        };
        -- Enedwaith
        [12] = {
            -- Little Wonders (Save index)
            [25] = {
                ["ISREPEATABLE"] = false;
                ["QUESTNAME"] = { ["EN"] = "Eriador / Enedwaith / Quest:Little Wonders\n    (Talk to a Ranger at Echad Idhrenfair about a small item you found.)"; };
            }
        };
        -- Dunland
        [13] = {
            -- Warg-slayer
            [42] = {
                ["ISREPEATABLE"] = false;
                ["QUESTNAME"] = { ["EN"] = "Eriador / The North Downs / Quest:Warg-slayer\n    (Defeat 8 wargs for Dagoras)"; };
            };
        };
    };
    -- Rhovanion
    [7] = {
        -- Moria
        [2] = {
            -- Warg-slayer
            [48] = {
                ["ISREPEATABLE"] = false;
                ["QUESTNAME"] = { ["EN"] = "Eriador / The North Downs / Quest:Warg-slayer\n    (Defeat 8 wargs for Dagoras)"; };
            };
        };
        -- Southern Mirkwood
        [3] = {
            -- Warg-slayer
            [21] = {
                ["ISREPEATABLE"] = false;
                ["QUESTNAME"] = { ["EN"] = "Eriador / The North Downs / Quest:Warg-slayer\n    (Defeat 8 wargs for Dagoras)"; };
            };
        };
        -- Eastern Rohan
        [5] = {
            -- Aiding the Eastemnet
            [46] = {
                ["ISREPEATABLE"] = true;
                ["QUESTNAME"] = { ["EN"] = "Rohan / Eastern Rohan / Quest:Aiding the Eastemnet\n    (Complete 5 quests from Aiding-specific quest givers in Harwick, Cliving, Eaworth, and Snowbourn.)"; };
            }
        };
        -- Wildermore
        [6] = {
            -- Farms of the Fallows
            [3] = {
                ["ISREPEATABLE"] = false;
                ["QUESTNAME"] = { ["EN"] = "Rohan / Wildermore / Quest:Farms of the Fallows\n    (Find Thrymm's Farm near Forlaw, Find 3 survivors, and Find Oter)"; };
            };
        };
        -- The Dwarf-holds
        [9] = {
            -- The Howling Pit
            -- [40] = {
            -- Quest requires completing the challenge, so deed should already be done
            --    ["ISREPEATABLE"] = false;
            --    ["QUESTNAME"] = { ["EN"] = "Rhovanian / Dwarf-holds: The Ironfold / Quest:The Howling Pit\n    (Complete Challenge: The Howling Pit)"; };
            --};
        };
        -- Vales of Anduin
        [10] = {
            -- Protectors of the Wilderfolk
            [28] = {
                ["ISREPEATABLE"] = false;
                ["QUESTNAME"] = { ["EN"] = "Rohan / The Vales of Anduin / Quest:Protectors of the Wilderfolk\n    (Talk to Ragnild, Audvak, and Hithril in Hultvís)"; };
            };
        };
    };
    -- Gondor
    [8] = {
        -- Far Anórien
        [5] = {
            -- After the Battle
            [23] = {
                ["ISREPEATABLE"] = false;
                ["QUESTNAME"] = { ["EN"] = "Gondor / Far Anórien / Quest:After the Battle\n    (Talk to Imrahil after the Battle of the Pelennor Fields)"; };
            };
        };
    };
};

function DoesDeedQuestExist(i, j, saveIndex)
    local questExists = 
        _CONFLICTING_QUESTS[i] ~= nil and
        _CONFLICTING_QUESTS[i][j] ~= nil and
        _CONFLICTING_QUESTS[i][j][saveIndex] ~= nil;
    return questExists;
end

function DoesDeedHaveConflictingQuest(i, j, saveIndex)
    local questExists = DoesDeedQuestExist(i, j, saveIndex);

    local isRepeatable = false;
    if (questExists) then isRepeatable = _CONFLICTING_QUESTS[i][j][saveIndex].ISREPEATABLE; end

    local questCompleted = GetConflictingQuestComplete(i, j, saveIndex);

    if (questExists and (isRepeatable or not questCompleted)) then
        return true;
    else
        return false;
    end
end

function WasThereAnnouncementOfConflictingQuest(i, j, saveIndex)
    local questExists = DoesDeedQuestExist(i, j, saveIndex);

    local isAnnounced = false;
    local isDelayed = false;
    if (questExists) then 
        local announceText = GetString(_CONFLICTING_QUESTS[i][j][saveIndex].ANNOUNCE);
        if (announceText ~= nil and announceText ~= "") then
            local previousMatch = string.find(PREVIOUS_QUEST_CHAT, announceText, 1, true);
            isAnnounced = previousMatch ~= nil;
        end

        if (_CONFLICTING_QUESTS[i][j][saveIndex].ISDELAYED and
            DELAYED_SKIRMISH_COMPLETION_CHAT ~= nil) then

            Debug(string.format("Deed %d, %d, %d is delayed: %d", i, j, saveIndex, DELAYED_SKIRMISH_COMPLETION_CHAT));

            isDelayed = true;
        end 
    end

    Debug("Checking announcement of conflicting quest... announced: " .. tostring(isAnnounced) .. ", delayed: " .. tostring(isDelayed));

    return isAnnounced or isDelayed;
end

function CheckForDelayedText(message)
    for i=1, table.maxn(_CONFLICTING_QUESTS[1][1]) do
        if (_CONFLICTING_QUESTS[1][1][i] ~= nil and
            _CONFLICTING_QUESTS[1][1][i].ISDELAYED) then
            local announceText = GetString(_CONFLICTING_QUESTS[1][1][i].ANNOUNCE);
            local findResult = string.find(message, announceText, 1, true);

            if (findResult ~= nil) then
                DELAYED_SKIRMISH_COMPLETION_CHAT = findResult;
                if (DELAYED_SKIRMISH_COMPLETION_CHAT ~= nil) then
                    Debug("Found delayed skirmish completion text: " .. DELAYED_SKIRMISH_COMPLETION_CHAT);
                end
            end
        end
    end
end