-- Some deeds are completed following instance play, before plugins are loaded.
-- If they place a reward item in the player's inventory, we can check for that.

_COMPLETED_DEED_ITEMS = {
    [1] = {
        ["ITEM"] = { ["EN"] = "Dúnadan Workman's Outfit Gift Box"; };
        ["DEED"] = { ["EN"] = "Volume III Interludes, Part One"; };
    };
    [2] = {
        ["ITEM"] = { ["EN"] = "Woodland Ranger's Outfit Gift Box"; };
        ["DEED"] = { ["EN"] = "Volume III Interludes, Part Two"; };
    };
}

function CheckForDeedItems()
    local backpack = MYCHAR:GetBackpack();
    local capacity = backpack:GetSize();

    for backpackItemIndex = 1, capacity do
        local backpackItem = backpack:GetItem(backpackItemIndex);
        if (backpackItem ~= nil) then
            local backpackItemName = backpackItem:GetName();

            for deedItemIndex = 1, table.maxn(_COMPLETED_DEED_ITEMS) do
                local deedItem = _COMPLETED_DEED_ITEMS[deedItemIndex];
                local deedItemName = GetString(deedItem["ITEM"]);

                if (backpackItemName == deedItemName) then
                    local deedName = GetString(_COMPLETED_DEED_ITEMS[deedItemIndex]["DEED"]);
                    IfDeedMarkComplete(MYCHAR:GetName(), deedName)
                end
            end
        end
    end
end
